mbed TLS v2.16.3: sha256.h File Reference

mbed TLS v2.16.3

Data Structures | Macros | Typedefs | Functions
sha256.h File Reference

This file contains SHA-224 and SHA-256 definitions and functions. More...

`#include "config.h"`
`#include <stddef.h>`
`#include <stdint.h>`
Include dependency graph for sha256.h:

Go to the source code of this file.

## Data Structures
struct | mbedtls_sha256_context
| The SHA-256 context structure. More...

## Macros
#define | MBEDTLS_ERR_SHA256_HW_ACCEL_FAILED -0x0037
#define | MBEDTLS_ERR_SHA256_BAD_INPUT_DATA -0x0074
#define | MBEDTLS_DEPRECATED

## Typedefs
typedef struct mbedtls_sha256_context | mbedtls_sha256_context
| The SHA-256 context structure. More...

## Functions
void | mbedtls_sha256_init (mbedtls_sha256_context *ctx)
| This function initializes a SHA-256 context. More...
void | mbedtls_sha256_free (mbedtls_sha256_context *ctx)
| This function clears a SHA-256 context. More...
void | mbedtls_sha256_clone (mbedtls_sha256_context *dst, const mbedtls_sha256_context *src)
| This function clones the state of a SHA-256 context. More...
int | mbedtls_sha256_starts_ret (mbedtls_sha256_context *ctx, int is224)
| This function starts a SHA-224 or SHA-256 checksum calculation. More...
int | mbedtls_sha256_update_ret (mbedtls_sha256_context *ctx, const unsigned char *input, size_t ilen)
| This function feeds an input buffer into an ongoing SHA-256 checksum calculation. More...
int | mbedtls_sha256_finish_ret (mbedtls_sha256_context *ctx, unsigned char output[32])
| This function finishes the SHA-256 operation, and writes the result to the output buffer. More...
int | mbedtls_internal_sha256_process (mbedtls_sha256_context *ctx, const unsigned char data[64])
| This function processes a single data block within the ongoing SHA-256 computation. This function is for internal use only. More...
MBEDTLS_DEPRECATED void | mbedtls_sha256_starts (mbedtls_sha256_context *ctx, int is224)
| This function starts a SHA-224 or SHA-256 checksum calculation. More...
MBEDTLS_DEPRECATED void | mbedtls_sha256_update (mbedtls_sha256_context *ctx, const unsigned char *input, size_t ilen)
| This function feeds an input buffer into an ongoing SHA-256 checksum calculation. More...
MBEDTLS_DEPRECATED void | mbedtls_sha256_finish (mbedtls_sha256_context *ctx, unsigned char output[32])
| This function finishes the SHA-256 operation, and writes the result to the output buffer. More...
MBEDTLS_DEPRECATED void | mbedtls_sha256_process (mbedtls_sha256_context *ctx, const unsigned char data[64])
| This function processes a single data block within the ongoing SHA-256 computation. This function is for internal use only. More...
int | mbedtls_sha256_ret (const unsigned char *input, size_t ilen, unsigned char output[32], int is224)
| This function calculates the SHA-224 or SHA-256 checksum of a buffer. More...
MBEDTLS_DEPRECATED void | mbedtls_sha256 (const unsigned char *input, size_t ilen, unsigned char output[32], int is224)
| This function calculates the SHA-224 or SHA-256 checksum of a buffer. More...
int | mbedtls_sha256_self_test (int verbose)
| The SHA-224 and SHA-256 checkup routine. More...

## Detailed Description

This file contains SHA-224 and SHA-256 definitions and functions.

The Secure Hash Algorithms 224 and 256 (SHA-224 and SHA-256) cryptographic hash functions are defined in FIPS 180-4: Secure Hash Standard (SHS).

Definition in file sha256.h.

## Macro Definition Documentation

## ◆ MBEDTLS_DEPRECATED [1/2]

#define MBEDTLS_DEPRECATED

Definition at line 250 of file sha256.h.

## ◆ MBEDTLS_DEPRECATED [2/2]

#define MBEDTLS_DEPRECATED

Definition at line 250 of file sha256.h.

## ◆ MBEDTLS_ERR_SHA256_BAD_INPUT_DATA

#define MBEDTLS_ERR_SHA256_BAD_INPUT_DATA -0x0074

SHA-256 input data was malformed.

Definition at line 41 of file sha256.h.

## ◆ MBEDTLS_ERR_SHA256_HW_ACCEL_FAILED

#define MBEDTLS_ERR_SHA256_HW_ACCEL_FAILED -0x0037

SHA-256 hardware accelerator failed

Definition at line 40 of file sha256.h.

## Typedef Documentation

## ◆ mbedtls_sha256_context

typedef struct mbedtls_sha256_context mbedtls_sha256_context

The SHA-256 context structure.

                The structure is used both for SHA-256 and for SHA-224
                checksum calculations. The choice between these two is
                made in the call to mbedtls_sha256_starts_ret().

## Function Documentation

## ◆ mbedtls_internal_sha256_process()

int mbedtls_internal_sha256_process | ( | mbedtls_sha256_context * | ctx,
|  | const unsigned char | data[64]
| ) |  |

This function processes a single data block within the ongoing SHA-256 computation. This function is for internal use only.

Parameters

  ctx | The SHA-256 context. This must be initialized.
  data | The buffer holding one block of data. This must be a readable buffer of length `64` Bytes.

Returns
  `0` on success.
  A negative error code on failure.

## ◆ mbedtls_sha256()

MBEDTLS_DEPRECATED void mbedtls_sha256 | ( | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char | output[32],
|  | int | is224
| ) |  |

This function calculates the SHA-224 or SHA-256 checksum of a buffer.

The function allocates the context, performs the calculation, and frees the context.

The SHA-256 result is calculated as output = SHA-256(input buffer).

Deprecated:
  Superseded by mbedtls_sha256_ret() in 2.7.0.

Parameters

  input | The buffer holding the data. This must be a readable buffer of length `ilen` Bytes.
  ilen | The length of the input data in Bytes.
  output | The SHA-224 or SHA-256 checksum result. This must be a writable buffer of length `32` Bytes.
  is224 | Determines which function to use. This must be either `0` for SHA-256, or `1` for SHA-224.

## ◆ mbedtls_sha256_clone()

void mbedtls_sha256_clone | ( | mbedtls_sha256_context * | dst,
|  | const mbedtls_sha256_context * | src
| ) |  |

This function clones the state of a SHA-256 context.

Parameters

  dst | The destination context. This must be initialized.
  src | The context to clone. This must be initialized.

## ◆ mbedtls_sha256_finish()

MBEDTLS_DEPRECATED void mbedtls_sha256_finish | ( | mbedtls_sha256_context * | ctx,
|  | unsigned char | output[32]
| ) |  |

This function finishes the SHA-256 operation, and writes the result to the output buffer.

Deprecated:
  Superseded by mbedtls_sha256_finish_ret() in 2.7.0.

Parameters

  ctx | The SHA-256 context. This must be initialized and have a hash operation started.
  output | The SHA-224 or SHA-256 checksum result. This must be a writable buffer of length `32` Bytes.

## ◆ mbedtls_sha256_finish_ret()

int mbedtls_sha256_finish_ret | ( | mbedtls_sha256_context * | ctx,
|  | unsigned char | output[32]
| ) |  |

This function finishes the SHA-256 operation, and writes the result to the output buffer.

Parameters

  ctx | The SHA-256 context. This must be initialized and have a hash operation started.
  output | The SHA-224 or SHA-256 checksum result. This must be a writable buffer of length `32` Bytes.

Returns
  `0` on success.
  A negative error code on failure.

## ◆ mbedtls_sha256_free()

void mbedtls_sha256_free | ( | mbedtls_sha256_context * | ctx | ) |

This function clears a SHA-256 context.

Parameters

  ctx | The SHA-256 context to clear. This may be `NULL`, in which case this function returns immediately. If it is not `NULL`, it must point to an initialized SHA-256 context.

## ◆ mbedtls_sha256_init()

void mbedtls_sha256_init | ( | mbedtls_sha256_context * | ctx | ) |

This function initializes a SHA-256 context.

Parameters

  ctx | The SHA-256 context to initialize. This must not be `NULL`.

## ◆ mbedtls_sha256_process()

MBEDTLS_DEPRECATED void mbedtls_sha256_process | ( | mbedtls_sha256_context * | ctx,
|  | const unsigned char | data[64]
| ) |  |

This function processes a single data block within the ongoing SHA-256 computation. This function is for internal use only.

Deprecated:
  Superseded by mbedtls_internal_sha256_process() in 2.7.0.

Parameters

  ctx | The SHA-256 context. This must be initialized.
  data | The buffer holding one block of data. This must be a readable buffer of size `64` Bytes.

## ◆ mbedtls_sha256_ret()

int mbedtls_sha256_ret | ( | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char | output[32],
|  | int | is224
| ) |  |

This function calculates the SHA-224 or SHA-256 checksum of a buffer.

The function allocates the context, performs the calculation, and frees the context.

The SHA-256 result is calculated as output = SHA-256(input buffer).

Parameters

  input | The buffer holding the data. This must be a readable buffer of length `ilen` Bytes.
  ilen | The length of the input data in Bytes.
  output | The SHA-224 or SHA-256 checksum result. This must be a writable buffer of length `32` Bytes.
  is224 | Determines which function to use. This must be either `0` for SHA-256, or `1` for SHA-224.

## ◆ mbedtls_sha256_self_test()

int mbedtls_sha256_self_test | ( | int | verbose | ) |

The SHA-224 and SHA-256 checkup routine.

Returns
  `0` on success.
  `1` on failure.

## ◆ mbedtls_sha256_starts()

MBEDTLS_DEPRECATED void mbedtls_sha256_starts | ( | mbedtls_sha256_context * | ctx,
|  | int | is224
| ) |  |

This function starts a SHA-224 or SHA-256 checksum calculation.

Deprecated:
  Superseded by mbedtls_sha256_starts_ret() in 2.7.0.

Parameters

  ctx | The context to use. This must be initialized.
  is224 | Determines which function to use. This must be either `0` for SHA-256, or `1` for SHA-224.

## ◆ mbedtls_sha256_starts_ret()

int mbedtls_sha256_starts_ret | ( | mbedtls_sha256_context * | ctx,
|  | int | is224
| ) |  |

This function starts a SHA-224 or SHA-256 checksum calculation.

Parameters

  ctx | The context to use. This must be initialized.
  is224 | This determines which function to use. This must be either `0` for SHA-256, or `1` for SHA-224.

Returns
  `0` on success.
  A negative error code on failure.

## ◆ mbedtls_sha256_update()

MBEDTLS_DEPRECATED void mbedtls_sha256_update | ( | mbedtls_sha256_context * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen
| ) |  |

This function feeds an input buffer into an ongoing SHA-256 checksum calculation.

Deprecated:
  Superseded by mbedtls_sha256_update_ret() in 2.7.0.

Parameters

  ctx | The SHA-256 context to use. This must be initialized and have a hash operation started.
  input | The buffer holding the data. This must be a readable buffer of length `ilen` Bytes.
  ilen | The length of the input data in Bytes.

## ◆ mbedtls_sha256_update_ret()

int mbedtls_sha256_update_ret | ( | mbedtls_sha256_context * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen
| ) |  |

This function feeds an input buffer into an ongoing SHA-256 checksum calculation.

Parameters

  ctx | The SHA-256 context. This must be initialized and have a hash operation started.
  input | The buffer holding the data. This must be a readable buffer of length `ilen` Bytes.
  ilen | The length of the input data in Bytes.

Returns
  `0` on success.
  A negative error code on failure.